# Antichrist Bot

**Antichrist Bot** is a flexible and extensible tool designed to automate tasks, interact with users, and integrate with various services in the Matrix ecosystem. The bot is built on a modular architecture that allows you to easily add, remove, or customize functionality depending on your needs. Each module is responsible for a specific task, making the bot versatile and easy to use.

## Modules

### RSS Module
The **RSS Module** allows the bot to subscribe to RSS feeds and automatically post updates to specified Matrix rooms. Users can manage subscriptions, set custom templates for feed updates, and control the frequency of updates.

**Features:**
- **Add RSS Feeds:** Subscribe to new RSS feeds using the `rss add <feed_url>` command.
- **Remove RSS Feeds:** Unsubscribe from RSS feeds using the `rss remove <index>` command.
- **List Subscriptions:** View all active RSS subscriptions in a room with the `rss list` command.
- **Custom Templates:** Define custom templates for formatting RSS updates using the `template` command.
- **Automatic Updates:** The bot periodically checks subscribed feeds for new content and posts updates to the room.

**Commands:**
- `rss add <feed_url>`: Add a new RSS feed subscription.
- `rss remove <index>`: Remove an RSS feed subscription by index.
- `rss list`: List all RSS feed subscriptions in the room.
- `template add <name> <content>`: Add a new template for formatting RSS updates.
- `template set <index> <template_name>`: Set a template for a specific RSS feed subscription.
- `template list`: List all templates available in the room.

### Autojoin Module
The **Autojoin Module** automatically joins the bot to any rooms it is invited to. This module is useful for ensuring the bot is always available in the rooms where it is needed without manual intervention.

### Ping Module
The **Ping Module** provides basic utility commands for testing and debugging. It includes commands to check the bot's responsiveness and to echo messages back to the user.

**Features:**
- **Ping Command:** Responds with "Pong!" and the latency in milliseconds.
- **Echo Command:** Repeats the provided message back to the user.

**Commands:**
- `ping`: Check the bot's responsiveness.
- `echo <message>`: Repeat the provided message.

## Getting Started

To get started with **Antichrist Bot**, follow these steps:

1. **Installation:** Clone the repository.
   - ```commandline
     git clone https://codeberg.org/D3M0N/antichrist_bot.git
     cd antichrist_bot
     ```
2. **Configuration:** Modify the configuration files to set up the bot's credentials and desired modules.
   - change the values in the config `configs/example.config.toml`
   - rename the config `mv configs/example.config.toml configs/config.toml`
3. **Run the Bot:** Start the bot using the provided startup script.
   - Directly with Python:
    ```commandline
    python -m venv .venv
    source .venv/bin/activate
    python main.py
    ```
   - Using Docker: Build and run the bot with Docker Compose:
    ```commandline
    docker-compose up -d
    ```
4. **Invite the Bot:** Invite the bot to your Matrix rooms and start using its features.

## License
**Antichrist Bot** is licensed under the [GPLv3](LICENSE).
