from typing import Protocol
from nio import AsyncClient
from core.config import ConfigManager
from core.command import CommandProcessor
from core.event_dispatcher import EventDispatcher

class BotInterface(Protocol):
    @property
    def client(self) -> AsyncClient:
        ...

    @property
    def command_processor(self) -> CommandProcessor:
        ...

    @property
    def event_dispatcher(self) -> EventDispatcher:
        ...

    @property
    def config(self) -> ConfigManager:
        ...
