from nio import InviteMemberEvent, MatrixRoom
from core.base_module import BaseModule
from core.logger import logger


class AutoJoinModule(BaseModule):
    def __init__(self, bot):
        super().__init__(bot)

    def on_start(self):
        logger.info("AutoJoinModule started")

    def on_stop(self):
        logger.info("AutoJoinModule stopped")

    @BaseModule.on_event(InviteMemberEvent)
    async def on_invite(self, room: MatrixRoom, event: InviteMemberEvent):
        logger.info(f"Received invite to room {room.room_id} from {event.sender}")

        try:
            await self.bot.client.join(room.room_id)
            logger.info(f"Joined room {room.room_id}")
        except Exception as e:
            logger.error(f"Failed to join room {room.room_id}: {e}")
