import time
from nio import MatrixRoom, Event
from core.logger import logger
from core.base_module import BaseModule

class PingModule(BaseModule):
    def on_start(self):
        logger.info("PingModule started")

    def on_stop(self):
        logger.info("PingModule stopped")

    @BaseModule.command_handler(name="ping", description="echo command")
    async def ping(self, room: MatrixRoom, args, event: Event):
        ping_time = int(time.time() * 1000) - event.server_timestamp
        await self.send_message(room.room_id, f"Pong! {ping_time}ms")

    @BaseModule.command_handler(name="echo", description="echo command")
    async def echo(self, room: MatrixRoom, args, event: Event):
        await self.send_message(room.room_id, " ".join(args))
